unit Grider;

{ Program copyright (c) 1995 by Charles Calvert }
{ Project Name: DELALLDB }

interface

uses
  SysUtils, WinTypes, WinProcs,
  Messages, Classes, Graphics,
  Controls, Forms, Dialogs,
  Grids, DBGrids, DB,
  Menus, DbTables, DBCtrls, ExtCtrls;

type
  TGridView = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    MainMenu1: TMainMenu;
    Sorts1: TMenuItem;
    ByDirectory1: TMenuItem;
    BySize1: TMenuItem;
    Swap1: TMenuItem;
    Stats1: TMenuItem;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    procedure BySize1Click(Sender: TObject);
    procedure Swap1Click(Sender: TObject);
    procedure TotalSize1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GridView: TGridView;

implementation

uses
  Main;

{$R *.DFM}

procedure TGridView.BySize1Click(Sender: TObject);
begin
  case TMenuItem(Sender).Tag of
    0: TTable(DataSource1.DataSet).IndexName := '';
    1: TTable(DataSource1.DataSet).IndexName := 'DirSizeIndex';
  end;
end;

procedure TGridView.Swap1Click(Sender: TObject);
begin
  TTable(DataSource1.DataSet).Fields[0].Index := 1;
end;

procedure TGridView.TotalSize1Click(Sender: TObject);
var
  Total, i: LongInt;
  S: string;
begin
  DataSource1.Enabled := False;
  Total := 0;
  i := 0;
  Form1.Table1.First;
  while not Form1.Table1.EOF do begin
    Total := Total + Form1.Table1.FieldByName('Size').AsInteger;
    Form1.Table1.Next;
    Inc(i);
  end;
  S := Format('Total Size = %d' + #13 + 'Count = %d', [Total, i]);
  DataSource1.Enabled := True;
  MessageDlg(S, mtInformation, [mbOk], 0);
end;

end.
